﻿'------------------------------------------------------------------------------
' <auto-generated>
'     このコードはテンプレートから生成されました。
'
'     このファイルを手動で変更すると、アプリケーションで予期しない動作が発生する可能性があります。
'     このファイルに対する手動の変更は、コードが再生成されると上書きされます。
' </auto-generated>
'------------------------------------------------------------------------------

Imports System
Imports System.Data.Entity
Imports System.Data.Entity.Infrastructure
Imports System.Data.Entity.Core.Objects
Imports System.Linq

Partial Public Class SchoolDBEntities
    Inherits DbContext

    Public Sub New()
        MyBase.New("name=SchoolDBEntities")
    End Sub

    Protected Overrides Sub OnModelCreating(modelBuilder As DbModelBuilder)
        Throw New UnintentionalCodeFirstException()
    End Sub

    Public Overridable Property Courses() As DbSet(Of Course)
    Public Overridable Property Standards() As DbSet(Of Standard)
    Public Overridable Property Students() As DbSet(Of Student)
    Public Overridable Property StudentAddresses() As DbSet(Of StudentAddress)
    Public Overridable Property Teachers() As DbSet(Of Teacher)
    Public Overridable Property View_StudentCourse() As DbSet(Of View_StudentCourse)

    Public Overridable Function GetCoursesByStudentId(studentId As Nullable(Of Integer)) As ObjectResult(Of GetCoursesByStudentId_Result)
        Dim studentIdParameter As ObjectParameter = If(studentId.HasValue, New ObjectParameter("StudentId", studentId), New ObjectParameter("StudentId", GetType(Integer)))

        Return DirectCast(Me, IObjectContextAdapter).ObjectContext.ExecuteFunction(Of GetCoursesByStudentId_Result)("GetCoursesByStudentId", studentIdParameter)
    End Function

    Public Overridable Function sp_DeleteStudent(studentId As Nullable(Of Integer)) As Integer
        Dim studentIdParameter As ObjectParameter = If(studentId.HasValue, New ObjectParameter("StudentId", studentId), New ObjectParameter("StudentId", GetType(Integer)))

        Return DirectCast(Me, IObjectContextAdapter).ObjectContext.ExecuteFunction("sp_DeleteStudent", studentIdParameter)
    End Function

    Public Overridable Function sp_InsertStudentInfo(standardId As Nullable(Of Integer), studentName As String) As Integer
        Dim standardIdParameter As ObjectParameter = If(standardId.HasValue, New ObjectParameter("StandardId", standardId), New ObjectParameter("StandardId", GetType(Integer)))

        Dim studentNameParameter As ObjectParameter = If(studentName IsNot Nothing, New ObjectParameter("StudentName", studentName), New ObjectParameter("StudentName", GetType(String)))

        Return DirectCast(Me, IObjectContextAdapter).ObjectContext.ExecuteFunction("sp_InsertStudentInfo", standardIdParameter, studentNameParameter)
    End Function

    Public Overridable Function sp_UpdateStudent(studentId As Nullable(Of Integer), standardId As Nullable(Of Integer), studentName As String) As Integer
        Dim studentIdParameter As ObjectParameter = If(studentId.HasValue, New ObjectParameter("StudentId", studentId), New ObjectParameter("StudentId", GetType(Integer)))

        Dim standardIdParameter As ObjectParameter = If(standardId.HasValue, New ObjectParameter("StandardId", standardId), New ObjectParameter("StandardId", GetType(Integer)))

        Dim studentNameParameter As ObjectParameter = If(studentName IsNot Nothing, New ObjectParameter("StudentName", studentName), New ObjectParameter("StudentName", GetType(String)))

        Return DirectCast(Me, IObjectContextAdapter).ObjectContext.ExecuteFunction("sp_UpdateStudent", studentIdParameter, standardIdParameter, studentNameParameter)
    End Function

End Class
